angular.module('beamng.apps')
	// register service
	.factory('VehicleService', function() {
		var vehicleNameStr = "";
		return {
			getVehicleName: function() { 
				return vehicleNameStr; 
			},
			setVehicleName: function(newVehicleName) 	{ 
				vehicleNameStr = newVehicleName.replace(/_/gi," ")
				},
		};
	})
	.directive('vehicleName', ['VehicleService', function (VehicleService) {
		return {
			template:
        '<div style="width:100%; height:100%;" layout="column" layout-align="center center" class="bngApp">' +
          '<span style="font-size:1.3em; text-align:center; text-transform: capitalize;" > Current Vehicle: {{ vehicleNameStr }}</span>' +
        '</div>',
			replace: true,
			link:
			function (scope, element, attrs) {
				// assign vehicleName to currently stored value in VehicleService
				scope.vehicleNameStr = VehicleService.getVehicleName();
				
				scope.$on("VehicleChange", function(event, data) {
					// get current vehicle
					bngApi.engineLua("core_vehicles.getCurrentVehicleDetails()", function(vehicle) {
						scope.$evalAsync(function() {
							// save current vehicle key
							VehicleService.setVehicleName(vehicle.current.key);
							scope.vehicleNameStr = VehicleService.getVehicleName();
						})
					})
				})

				scope.$on('VehicleFocusChanged', function (event, data) {
					// get current vehicle
					bngApi.engineLua("core_vehicles.getCurrentVehicleDetails()", function(vehicle) {
						scope.$evalAsync(function() {
							// save current vehicle key
							VehicleService.setVehicleName(vehicle.current.key);
							scope.vehicleNameStr = VehicleService.getVehicleName();
						})
					})
				});
			}
		};
		
	}])
